#ifdef DEBUG
	#define Assert(e) if (!(e)) { throw Obelisk::CException("Assertion failed: " #e); }
#else
	#define Assert(e)
#endif

namespace Obelisk
{
	typedef unsigned char TByte;
	#ifdef PLATFORM_WINDOWS
		typedef wchar_t TCodeUnit;
	#else
		typedef char TCodeUnit;
	#endif
	extern const TCodeUnit *gEmptyString;



	template <typename T> inline T Min(const T& a, const T& b)
	{
		return a <= b ? a : b;
	}



	template <typename T> inline T Max(const T& a, const T& b)
	{
		return a >= b ? a : b;
	}



	template <typename T> inline void Swap(T& a, T& b)
	{
		T t = a;
		a = b;
		b = t;
	}
}

#include "CException.h"
#include "CString.h"
#include "CStringMap.h"
#include "CCollection.h"

#include "IObelisk.h"
#include "IThreadObelisk.h"
#include "IThread.h"
#include "IReader.h"
#include "IWriter.h"
#include "IMainController.h"
#include "CTexture.h"
#include "CVector.h"
#include "CColour.h"

Obelisk::IMainController* CreateMainController(Obelisk::IObelisk* aObelisk);