#include <stdarg.h>
#include <stdio.h>
#include <string.h>

#include "CException.h"

using namespace Obelisk;

#ifdef PLATFORM_LINUX
	#define _vsnprintf vsnprintf
#endif



CException::CException()
{
	mMessage = new char [1];
	strcpy(mMessage, "");
}



CException::CException(const char* aFmt, ...)
{
	va_list Arg;
	va_start(Arg, aFmt);
	int Length = _vsnprintf(NULL, 0, aFmt, Arg);
	mMessage = new char [Length + 1];
	_vsnprintf(mMessage, Length + 1, aFmt, Arg);
	va_end(Arg);
}



CException::CException(const CException& aException)
{
	mMessage = new char [strlen(aException.mMessage) + 1];
	strcpy(mMessage, aException.mMessage);
}



CException& CException::operator =(const CException& aException)
{
	delete [] mMessage;
	mMessage = new char [strlen(aException.mMessage) + 1];
	strcpy(mMessage, aException.mMessage);
	return *this;
}