﻿#include <windows.h>
#include <gl\gl.h>
#pragma hdrstop

#include "Shared.h"
#include "CFileWrapper.h"

using namespace Obelisk;



CFileWrapper::CFileWrapper(HANDLE aFile, bool aInterruptable)
{
	mFile = aFile;
	mInterruptable = aInterruptable;
	mError = false;
}



CFileWrapper::~CFileWrapper()
{
	bool CHResult = CloseHandle(mFile);
	Assert(CHResult)
}



bool CFileWrapper::Read(TByte* aData, int aNumBytes)
{
	if (mError)
		throw CException("File is in error state");
	DWORD BytesRead;
	if (!ReadFile(mFile, aData, aNumBytes, &BytesRead, NULL))
	{
		if (!mInterruptable || GetLastError() != ERROR_OPERATION_ABORTED)
			throw CException("ReadFile() failed");
		mError = true;
		return false;
	}
	mError = BytesRead != aNumBytes;
	return !mError;
}



bool CFileWrapper::Write(TByte* aData, int aNumBytes)
{
	if (mError)
		throw CException("File is in error state");
	DWORD BytesWritten;
	if (!WriteFile(mFile, aData, aNumBytes, &BytesWritten, NULL))
	{
		if (!mInterruptable || GetLastError() != ERROR_OPERATION_ABORTED)
			throw CException("WriteFile() failed");
		mError = true;
		return false;
	}
	mError = BytesWritten != aNumBytes;
	return !mError;
}