#include <utility>

class CMap;
class CKnifeBot;

class CBlade
{
public:
	CBlade(CMap* aMap, int aX, int aY, float aAngle);

	int GetX() { return mX; }
	int GetY() { return mY; }
	float GetAngle() { return mAngle; }

	void SetAngle(float aAngle) { mAngle = aAngle; }

	bool IsStationary() { return mKnifeBot == NULL; }
	bool IsActive() { return mKnifeBot != NULL; }
	bool IsAttached() { return mAttached; }
	bool IsFlying() { return !mAttached && mKnifeBot != NULL; }
	CKnifeBot* GetKnifeBot() { return mKnifeBot; }
	void SetAttached(CKnifeBot* aKnifeBot, bool aAttached);

	void Move(int aX, int aY, float aAngle);

	float GetOffset() { return mOffset; }
	void SetOffset(float aOffset) { mOffset = aOffset; }

	void Launch(Obelisk::IObelisk* aObelisk);
	void LaunchAngle(Obelisk::IObelisk* aObelisk, float aAngle);

	void Step();

	float GetFlyingAngle() { return mVelocity.first; }

	int GetGeneration() { return mGeneration; }
	void SetGeneration(int aGeneration) { mGeneration = aGeneration; }

private:
	CMap *mMap;
	int mX;
	int mY;
	float mAngle;
	bool mAttached;
	CKnifeBot *mKnifeBot;

	float mOffset;

	std::pair<float, float> mVelocity;
	std::pair<float, float> mRealPos;

	int mGeneration;
};