class CMap;

class CGameController
{
public:
	CGameController(Obelisk::IObelisk* aObelisk);
	~CGameController();

	bool Update();
	void Render();

	unsigned int GetScore() { return mTimeScore + mBladeScore; }

	void BladeCrash();
	void GetEMP() { mNumEMPs++; }
	void BladeScore(int aAmount) { mBladeScore += aAmount; }

private:
	const int cXSize;
	const int cYSize;

	Obelisk::IObelisk* mObelisk;
	CMap *mMap;

	float mProjectionMatrix[16];

	int mPlayerLastDir;
	int mPlayerFrame;
	int mPlayerFrameCount;
	Obelisk::CTexture mPlayerLeftTexture[2];
	Obelisk::CTexture mPlayerRightTexture[2];
	Obelisk::CTexture mPlayerVerticalTexture[2];
	bool mPlayerOldInvincible;
	int mPlayerInvincibleFrameCount;
	int mPlayerInvincibleFrame;

	Obelisk::CTexture mKnifeBotTexture;
	Obelisk::CTexture mBladeTexture;

	unsigned int mTime;
	unsigned int mTimeScore;
	unsigned int mBladeScore;

	int mNumEMPs;
	bool mSpacePressed;

	int mNextSound;
	int mBladeCrashSound;
	int mEMPSound;

	Obelisk::CTexture mPowerUpTextures[2];
	Obelisk::CTexture mMarkerTextures[2];
};