#include <vector>

class CMap;
class CBlade;

class CKnifeBot
{
public:
	CKnifeBot(CMap* aMap, int aX, int aY, int aDir, bool aOrientation);

	int GetX() { return mX; }
	int GetY() { return mY; }
	float GetAngle() { return mAngle; }
	bool GetOrientation() { return mOrientation; }

	void Step(Obelisk::IObelisk* aObelisk);

	int NumBlades() { return mBlades.size(); }
	CBlade* GetBlade(int aIndex) { return mBlades[aIndex]; }
	bool IsAttached(CBlade* aBlade);
	void AttachBlade(Obelisk::IObelisk* aObelisk, CBlade* aBlade);
	void DetachBlade(CBlade* aBlade);

private:
	CMap *mMap;
	int mX;
	int mY;
	float mAngle;
	int mDir;
	bool mOrientation;
	int mMode;
	int mSteps;

	std::vector<CBlade*> mBlades;
	float mBladeAngle;
};